package net.t2code.commandguiv2.Spigot.cmdManagement;

import net.t2code.commandguiv2.Spigot.config.config.Config;
import net.t2code.commandguiv2.Spigot.config.functions.FunctionsFile;
import net.t2code.commandguiv2.Spigot.config.gui.GuiFile;
import net.t2code.commandguiv2.Spigot.config.languages.Languages;
import net.t2code.commandguiv2.Spigot.useItem.Events;
import net.t2code.commandguiv2.Spigot.Main;
import net.t2code.commandguiv2.Spigot.objects.Gui;
import net.t2code.commandguiv2.Spigot.cmdManagement.register.AliasRegister;
import net.t2code.commandguiv2.Spigot.gui.OpenGUI;
import net.t2code.commandguiv2.Spigot.useItem.UseItem;
import net.t2code.commandguiv2.Spigot.system.Permissions;
import net.t2code.commandguiv2.Spigot.database.SelectDatabase;
import net.t2code.commandguiv2.Spigot.sound.Sound;
import net.t2code.commandguiv2.Spigot.enums.SoundEnum;
import net.t2code.commandguiv2.Util;
import net.t2code.t2codelib.SPIGOT.api.debug.T2C_Debug;
import net.t2code.t2codelib.SPIGOT.api.messages.T2C_Send;
import net.t2code.t2codelib.SPIGOT.api.messages.T2C_Template;
import net.t2code.t2codelib.SPIGOT.system.T2C_Main;
import org.bukkit.Bukkit;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

import java.util.Objects;

public class Commands {
    public static void info(CommandSender sender) {
        T2C_Template.sendInfo(sender, Main.getPlugin(), Util.getSpigotID(), Util.getDiscord(), Util.getInfoText());
    }

    public static void reload(CommandSender sender) {
        Bukkit.getScheduler().runTaskAsynchronously(Main.getPlugin(), new Runnable() {
            @Override
            public void run() {
                if (sender instanceof Player) sender.sendMessage(Languages.VALUES.ReloadStart.getValue().toString());
                T2C_Send.console(Util.getPrefix() + "§8-------------------------------");
                T2C_Send.console(Util.getPrefix() + " §6Plugin reload...");
                T2C_Send.console(Util.getPrefix() + "§8-------------------------------");
                Config.set(true);
                Main.getPlugin().reloadConfig();

                CmdExecuter_GUI.arg1.clear();
                CmdExecuter_GUI.arg1.put(Config.VALUES.adminSubCommand.getValue().toString(), "commandgui.admin;commandgui.giveitem.other;commandgui.command.info");

                if (!Objects.equals(SelectDatabase.getStorage().toString(), Config.VALUES.storage.getValue().toString())) {
                    if (sender instanceof Player) T2C_Send.sender(sender, "You have changed the storage medium! To apply this change, you must restart the server!");
                    T2C_Send.warning(Main.getPlugin(), "You have changed the storage medium! To apply this change, you must restart the server!");
                }

                FunctionsFile.select(true);
                GuiFile.set(true);
                Languages.set(true);
                Config.checkSounds();

                try {
                    AliasRegister.onRegister(true);
                } catch (Exception e) {
                    e.printStackTrace();
                }
                try {
                    Permissions.onPermRegister();
                } catch (Exception e) {
                    e.printStackTrace();
                }

                if (T2C_Main.isProxy()) {
                    Bukkit.getMessenger().registerOutgoingPluginChannel(Main.getPlugin(), "commandgui:bungee");

                }

                if (sender instanceof Player) sender.sendMessage(Languages.VALUES.ReloadEnd.getValue().toString());
                T2C_Send.console(Util.getPrefix() + "§8-------------------------------");
                T2C_Send.console(Util.getPrefix() + " §2Plugin successfully reloaded.");
                T2C_Send.console(Util.getPrefix() + "§8-------------------------------");
            }
        });
    }

    public static void give(CommandSender sender, Player target) {
        if (Bukkit.getPlayer(target.getName()) != null) {
            UseItem.giveUseItem(target);
            T2C_Send.sender(sender, Languages.VALUES.Give_Sender.getValue().toString().replace("[player]", target.getName()).replace("[item]", Config.VALUES.useItemName.getValue().toString()));
            T2C_Send.player(target, Languages.VALUES.Give_Receiver.getValue().toString().replace("[sender]", sender.getName()).replace("[item]", Config.VALUES.useItemName.getValue().toString()));
            Sound.play(target, SoundEnum.Give);
        } else {
            sender.sendMessage(Languages.VALUES.PlayerNotFond.getValue().toString().replace("[player]", target.getName()));
            if (sender instanceof Player) Sound.play((Player) sender, SoundEnum.PlayerNotFound);
        }
    }

    public static void itemOn(Player player) {
        UseItem.removeItem(player);
        Integer slot = null;
        if ((boolean) Config.VALUES.useItemInventorySlotEnforce.getValue()) {
            slot = (int) Config.VALUES.useItemInventorySlot.getValue();
        } else {
            slot = Events.useItemSlotHashMap.get(player.getName());
        }
        T2C_Debug.debug(Main.getPlugin(), String.valueOf(slot));
        if (player.getInventory().getItem(slot - 1) == null) {
            SelectDatabase.setItemStatusTrue(player);
            UseItem.giveUseItem(player);
        } else {
            boolean empty = false;
            for (int i = 0; i < 9; i++) {
                if (player.getInventory().getItem(i) == null) {
                    empty = true;
                    break;
                }
            }
            if (empty) {
                SelectDatabase.setItemStatusTrue(player);
                UseItem.addUseItem(player);
                T2C_Send.player(player, Languages.VALUES.ItemON);
            } else {
                T2C_Send.player(player, Languages.VALUES.NoInventorySpace);
                Sound.play(player, SoundEnum.NoInventorySpace);
            }
        }
    }

    public static void itemOff(Player player) {
        SelectDatabase.setItemStatusFalse(player);
        UseItem.removeItem(player);
        T2C_Send.player(player, Languages.VALUES.ItemOFF);
    }

    public static void onSetSlot(Player player, Integer setSlot) {
        if (!(boolean) Config.VALUES.useItemAllowSetSlot.getValue()) {
            T2C_Send.player(player, Util.getPrefix() + " §4Function disabled");
            return;
        }

        if (setSlot < 1) {
            T2C_Send.player(player, Languages.VALUES.ItemSlot_wrongValue);
            return;
        }
        if (setSlot > 9) {
            T2C_Send.player(player, Languages.VALUES.ItemSlot_wrongValue);
            return;
        }

        if (Events.useItemHashMap.get(player.getName())) {
            if (Objects.equals(Events.useItemSlotHashMap.get(player.getName()), setSlot)) {
                T2C_Send.player(player, Languages.VALUES.ItemSlotAlreadySet.getValue().toString().replace("[slot]", setSlot.toString()));
                return;
            }
        }

        if ((boolean) Config.VALUES.useItemInventorySlotEnforce.getValue() || player.getInventory().getItem(setSlot - 1) != null) {
            T2C_Send.player(player, Languages.VALUES.ItemSlotNotEmpty.getValue().toString().replace("[slot]", setSlot.toString()));
            return;
        }

        UseItem.removeItem(player);
        SelectDatabase.setSlot(player, setSlot);
        Events.useItemSlotHashMap.replace(player.getName(), setSlot);

        if (Events.useItemHashMap.get(player.getName())) {
            UseItem.giveUseItem(player);
        }

        T2C_Send.player(player, Languages.VALUES.ItemSlot.getValue().toString().replace("[slot]", setSlot.toString()));
    }

    public static void gui(Player player) {
        if (Main.guiHashMap.containsKey(Config.VALUES.defaultGUI.getValue().toString())) {
            Gui gui = Main.guiHashMap.get(Config.VALUES.defaultGUI.getValue().toString());
            if (gui.guiEnable || player.hasPermission("commandgui.bypass")) {
                if (!gui.commandPermissionEnable || player.hasPermission("commandgui.command") || player.hasPermission("commandgui.bypass")) {
                    OpenGUI.openGUI(player, Config.VALUES.defaultGUI.toString(), true);
                } else T2C_Send.player(player, Languages.VALUES.NoPermissionForCommand.getValue().toString().replace("[cmd]", "/commandgui")
                        .replace("[perm]", "commandgui.command"));
            } else T2C_Send.player(player, Languages.VALUES.GUIIsDisabled.getValue().toString().replace("[gui]", gui.guiName));
        } else {
            T2C_Send.player(player, Languages.VALUES.guiNotFound.getValue().toString());
            T2C_Send.error(Main.getPlugin(), "");
            T2C_Send.console(Util.getPrefix()+ " <red>The gui <gold>[gui]</gold> that the player <gold>[player]</gold> wanted to open does not exist!".replace("[gui]", Config.VALUES.defaultGUI.getValue().toString()).replace("[player]", player.getName())); //todo in lang
            T2C_Send.error(Main.getPlugin(), "");
        }
    }

    public static void gui(Player player, String arg) {
        Gui gui = Main.guiHashMap.get(arg);
        if (gui == null) {
            T2C_Send.player(player, Languages.VALUES.guiNotFound.getValue().toString());
            T2C_Send.error(Main.getPlugin(), "");
            T2C_Send.console(Util.getPrefix()+ " <red>The gui <gold>[gui]</gold> that the player <gold>[player]</gold> wanted to open does not exist!".replace("[gui]", arg).replace("[player]", player.getName())); //todo in lang
            T2C_Send.error(Main.getPlugin(), "");
            return;
        }
        if (gui.guiEnable || player.hasPermission("commandgui.bypass")) {
            if (!gui.commandPermissionEnable || player.hasPermission("commandgui.command." + gui.key) || player.hasPermission("commandgui.bypass")) {
                OpenGUI.openGUI(player, arg, true);
            } else T2C_Send.player(player, Languages.VALUES.NoPermissionForCommand.getValue().toString().replace("[cmd]", "/commandgui " + gui.key)
                    .replace("[perm]", "commandgui.command." + arg.toLowerCase()));
        } else T2C_Send.player(player, Languages.VALUES.GUIIsDisabled.getValue().toString().replace("[gui]", gui.key));
    }
}
