package net.t2code.commandguiv2.Spigot.config.config;

import net.t2code.commandguiv2.Spigot.Main;
import net.t2code.commandguiv2.Spigot.config.languages.Languages;
import net.t2code.commandguiv2.Util;
import net.t2code.t2codelib.SPIGOT.api.items.T2C_ItemVersion;
import net.t2code.t2codelib.SPIGOT.api.messages.T2C_Send;
import net.t2code.t2codelib.SPIGOT.api.minecraftVersion.T2C_McVersion;
import net.t2code.t2codelib.SPIGOT.api.yaml.T2C_ConfigWriter;
import net.t2code.t2codelib.util.T2C_ConfigItem;
import net.t2code.t2codelib.util.T2C_LanguageEnum;
import org.bukkit.Material;
import org.bukkit.Sound;

import java.io.File;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

public class Config {

    public static enum VALUES implements T2C_ConfigItem {

        debug("plugin.debug", false, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        updateCheckOnJoin("plugin.updateCheck.onJoin", true, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),
        updateCheckSeePreReleaseUpdates("plugin.updateCheck.seePreReleaseUpdates", true, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),
        updateCheckTimeInterval("plugin.updateCheck.timeInterval", 60, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),
        helpAlias("plugin.helpAlias", true, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),
        adminSubCommand("plugin.adminSubCommand", "admin", true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),
        language("plugin.language", T2C_LanguageEnum.english, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),
        currency("plugin.currency", "$", true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),
        defaultGUI("plugin.defaultGUI", "default", true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),
        prefix("plugin.prefix", "&8[&4C&9GUI&8]", true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        storage("storage.type", Main.legacy ? "YML" : "SQLITE", true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Speichermöglichkeiten: YML, SQLITE, MYSQL"));
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        mysqlIp("storage.mysql.ip", "localhost", true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),
        mysqlPort("storage.mysql.port", 3306, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),
        mysqlDatabase("storage.mysql.database", "database", true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),
        mysqlUser("storage.mysql.user", "user", true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),
        mysqlPassword("storage.mysql.password", "password", true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),
        mysqlSSL("storage.mysql.ssl", false, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        useItemEnable("useItem.enable", true, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),
        useItemAllowToggle("useItem.allowToggle", true, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),
        useItemAllowSetSlot("useItem.allowSetSlot", true, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),
        useItemBlockMoveAndDrop("useItem.blockMoveAndDrop", true, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),
        useItemOpenGUI("useItem.openGUI", "default", true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),
        useItemPermissionNeeded("useItem.permission.neededToUse", true, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),
        useItemKeepAtCommandClear("useItem.keepAtCommandClear", true, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),


        useItemInventorySlot("useItem.inventorySlot.slot", 1, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),
        useItemInventorySlotEnforce("useItem.inventorySlot.slotEnforce", false, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),
        useItemInventorySlotFreeSlot("useItem.inventorySlot.freeSlot", false, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),
        useItemMaterial("useItem.item.material", "paper", true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        useItemPlayerHeadEnable(isHead() ? "useItem.item.playerHead.enable" : null, false, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        useItemBase64Enable(isHead() ? "useItem.item.playerHead.base64.enable" : null, false, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        useItemBase64value(isHead() ? "useItem.item.playerHead.base64.base64value" : null, "", true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        useItemPlayerWhoHasOpenedTheGUI(isHead() ? "useItem.item.playerHead.playerWhoHasOpenedTheGUI" : null, false, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        useItemPlayerName(isHead() ? "useItem.item.playerHead.playerName" : null, "", true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        useItemName("useItem.item.name", "&bDefault &6GUI", true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        useItemLore("useItem.item.lore", List.of("&eThis is an example GUI"), true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        useItemGiveOnEveryJoin("useItem.Join.GiveOnEveryJoin", true, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        useItemGiveOnlyOnFirstJoin("useItem.join.giveOnlyOnFirstJoin", false, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        cursorToGUIItemOnLogin("useItem.join.cursor.toGUIItem.onLogin.enable", true, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        cursorToGUIItemOnlyOnFirstLogin("useItem.join.cursor.toGUIItem.onlyOnFirstLogin", true, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        cursorUseItemServerChange("useItem.join.cursor.toGUIItem.onServerChange", false, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        toggleItemOnOrYesBase64("toggle.items.onOrYes.item.base64.enable", false, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        toggleItemOnOrYesBase64Value("toggle.items.onOrYes.item.base64.base64value", "", true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        toggleItemOnOrYesMaterial("toggle.items.onOrYes.item.material", Main.legacy ? "WOOL,5" : T2C_ItemVersion.getGreenWool().getType().toString(), true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        toggleItemOffOrNoBase64("toggle.items.offOrNo.item.base64.enable", false, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        toggleItemOffOrNoBase64Value("toggle.items.offOrNo.item.base64.base64value", "", true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        toggleItemOffOrNoMaterial("toggle.items.offOrNo.item.material", Main.legacy ? "WOOL,14" : T2C_ItemVersion.getRedWool().getType().toString(), true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        togglePermTrue("toggle.permission.commands.true", "luckperms user [player] permission set [perm] true", true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        togglePermFalse("toggle.permission.commands.false", "luckperms user [player] permission set [perm] false", true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        placeholderTrue("placeholder.true", "&2true", true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),

        placeholderFalse("placeholder.false", "&4false", true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),


        soundEnable("sound.enable", true, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        soundOpenInventoryEnable("sound.openInventory.enable", true, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        soundOpenInventory("sound.openInventory.sound", getSoundOpenInventory(), true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        soundClickEnable("sound.click.enable", true, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        soundClick("sound.click.sound", getSoundClick(), true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        soundNoMoneyEnable("sound.noMoney.enable", true, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        soundNoMoney("sound.noMoney.sound", getSoundNoMoney(), true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),

        soundNoInventorySpaceEnable("sound.noInventorySpace.enable", true, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        soundNoInventorySpace("sound.noInventorySpace.sound", getSoundNoInventorySpace(), true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        soundGiveEnable("sound.give.enable", true, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        soundGive("sound.give.sound", getSoundGive(), true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        soundPlayerNotFoundEnable("sound.playerNotFound.enable", true, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        soundPlayerNotFound("sound.playerNotFound.sound", getSoundPlayerNotFound(), true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),


        useItemGameModeChangeEnable("advanced.useItem.gameMode.change.enable", true, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        useItemGameModeChangeDelayInTicks("advanced.useItem.gameMode.change.delayInTicks", 1, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        useItemGameModeProtection("advanced.useItem.gameMode.protection.enable", false, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        useItemGameModeRemoveItemWhenItIsDisabled("advanced.useItem.gameMode.protection.removeItemWhenItIsDisabled", false, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        useItemGameModeMode("advanced.useItem.gameMode.protection.mode", "blacklist", true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),

        useItemGameModeList("advanced.useItem.gameMode.protection.list", List.of("CREATIVE", "SPECTATOR"), true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),

        useItemWorldChangeEnable("advanced.useItem.world.change.enable", true, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        useItemWorldChangeDelayInTicks("advanced.useItem.world.change.delayInTicks", 1, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        useItemWorldProtection("advanced.useItem.world.protection.enable", false, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        useItemWorldRemoveItemWhenItIsDisabled("advanced.useItem.world.protection.removeItemWhenItIsDisabled", false, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        useItemWorldMode("advanced.useItem.world.protection.mode", List.of("CREATIVE", "Spectator"), true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        useItemWorldList("advanced.useItem.world.protection.list", List.of("World1", "World2"), true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),


        //   if (yamlConfiguration.get("advanced.UseItem.DisableInfoBySneak") != null) {
        //      disableInfoBySneak = yamlConfiguration.getBoolean("advanced.UseItem.DisableInfoBySneak");
        //  }
        disableInfoBySneak("advanced.useItem.disableInfoBySneak", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),

        useItemItemBlockBlacklist("advanced.useItem.itemBlockBlacklist", getItemBlockBlacklist(), true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),

        ;
        private final String path;
        private Object value;
        private final boolean forceSet;
        private final HashMap<T2C_LanguageEnum, List<String>> comments;

        VALUES(String path, Object value, boolean forceSet, HashMap<T2C_LanguageEnum, List<String>> comments) {
            this.path = path;
            this.value = value;
            this.forceSet = forceSet;
            this.comments = comments;
        }

        @Override
        public String getPath() {
            return path;
        }

        @Override
        public Object getValue() {
            return value;
        }

        @Override
        public boolean getForceSet() {
            return forceSet;
        }

        @Override
        public HashMap<T2C_LanguageEnum, List<String>> getComments() {
            return comments;
        }

        @Override
        public String getLanguagePath() {
            return language.path;
        }

        @Override
        public void setValue(Object newValue) {
            value = newValue;
        }
    }

    public static void set(boolean isReload) {
        T2C_ConfigWriter.createConfig(Util.getPrefix(), new File(Main.getPath(), "config.yml"), VALUES.values(), isReload, Util.getConfigLogo());
        Util.replace(VALUES.prefix);
        Util.replace(VALUES.useItemName);
        Util.replace(VALUES.useItemLore);
        Util.replace(VALUES.placeholderFalse);
        Util.replace(VALUES.placeholderTrue);
    }

    private static boolean isHead() {
        if (!(T2C_McVersion.isMc1_8() || T2C_McVersion.isMc1_9() || T2C_McVersion.isMc1_10() || T2C_McVersion.isMc1_11() || T2C_McVersion.isMc1_12())) {
            return true;
        } else return false;
    }

    private static String getSoundOpenInventory() {
        if (T2C_McVersion.isMc1_8()) {
            return "CHEST_OPEN";
        }
        return "BLOCK_CHEST_OPEN";

    }

    private static String getSoundClick() {
        if (T2C_McVersion.isMc1_8()) {
            return "NOTE_STICKS";
        } else if (T2C_McVersion.isMc1_9() || T2C_McVersion.isMc1_10() || T2C_McVersion.isMc1_11() || T2C_McVersion.isMc1_12()) {
            return "BLOCK_NOTE_HAT";
        }
        return "BLOCK_NOTE_BLOCK_HAT";
    }

    private static String getSoundNoMoney() {
        if (T2C_McVersion.isMc1_8()) {
            return "NOTE_PIANO";
        } else if (T2C_McVersion.isMc1_9() || T2C_McVersion.isMc1_10() || T2C_McVersion.isMc1_11() || T2C_McVersion.isMc1_12()) {
            return "BLOCK_NOTE_HARP";
        }
        return "BLOCK_NOTE_BLOCK_HARP";
    }

    private static String getSoundNoInventorySpace() {
        if (T2C_McVersion.isMc1_8()) {
            return "NOTE_PIANO";
        } else if (T2C_McVersion.isMc1_9() || T2C_McVersion.isMc1_10() || T2C_McVersion.isMc1_11() || T2C_McVersion.isMc1_12()) {
            return "BLOCK_NOTE_BASS";
        }
        return "BLOCK_NOTE_BLOCK_GUITAR";
    }

    private static String getSoundGive() {
        if (T2C_McVersion.isMc1_8()) {
            return "LEVEL_UP";
        }
        return "ENTITY_PLAYER_LEVELUP";
    }

    private static String getSoundPlayerNotFound() {
        if (T2C_McVersion.isMc1_8()) {
            return "NOTE_PIANO";
        } else if (T2C_McVersion.isMc1_9() || T2C_McVersion.isMc1_10() || T2C_McVersion.isMc1_11() || T2C_McVersion.isMc1_12()) {
            return "BLOCK_NOTE_HARP";
        } else {
            return "BLOCK_NOTE_BLOCK_HARP";
        }
    }

    private static List<String> getItemBlockBlacklist() {
        List<String> materialList = Arrays.asList("BUTTON", "DOOR", "FENCE", "CHEST", "FURNACE", "NOTE_BLOCK", "CRAFTING_TABLE", "WORKBENCH",
                "ANVIL", "LOOM", "COMPOSTER", "BARREL", "SMOKER", "BLAST_FURNACE", "CARTOGRAPHY_TABLE", "FLETCHING_TABLE", "GRINDSTONE",
                "SMITHING_TABLE", "STONECUTTER", "HOPPER", "DISPENSER", "DROPPER", "REPEATER", "COMPARATOR", "LEVER", "DAYLIGHT_DETECTOR", "BREWING_STAND", "TRAPDOOR", "BEACON"
        );

        List<String> materialBlacklist = new ArrayList<>();
        for (Material material : Material.values()) {
            for (String target : materialList) {
                if (material.toString().contains(target)) {
                    materialBlacklist.add(material.toString());
                }
            }
        }
        return materialBlacklist;
    }

    public static void checkSounds() {
        checkSound(VALUES.soundOpenInventory, getSoundOpenInventory());
        checkSound(VALUES.soundClick, getSoundOpenInventory());
        checkSound(VALUES.soundNoMoney, getSoundOpenInventory());
        checkSound(VALUES.soundNoInventorySpace, getSoundOpenInventory());
        checkSound(VALUES.soundGive, getSoundOpenInventory());
        checkSound(VALUES.soundPlayerNotFound, getSoundOpenInventory());
    }

    public static void checkSound(VALUES item, String defaultSound) {
        try {
            item.setValue(Sound.valueOf(item.value.toString()).toString());
        } catch (Exception e) {
            T2C_Send.console("§4\n§4\n§4\n" + Languages.VALUES.SoundNotFound.getValue().toString().replace("[prefix]", Util.getPrefix())
                    .replace("[sound]", "§8" + item.getPath() + item.value.toString()) + "§4\n§4\n§4\n");
            item.setValue(Sound.valueOf(defaultSound).toString());
        }
    }
}
