// This class was created by JaTiTV.

package net.t2code.commandguiv2.Spigot.config.languages;

import net.t2code.commandguiv2.Spigot.Main;
import net.t2code.commandguiv2.Spigot.config.config.Config;
import net.t2code.commandguiv2.Util;
import net.t2code.t2codelib.SPIGOT.api.messages.T2C_Replace;
import net.t2code.t2codelib.SPIGOT.api.yaml.T2C_LanguageWriter;
import net.t2code.t2codelib.util.T2C_ConfigItemLanguages;
import net.t2code.t2codelib.util.T2C_LanguageEnum;

import java.util.HashMap;
import java.util.List;
import java.util.logging.Level;

public class Languages {
    public enum VALUES implements T2C_ConfigItemLanguages {

        VaultNotSetUp("Plugin.VaultNotSetUp", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("[prefix] <dark_red>Vault / Economy nicht eingerichtet!"));
                    put(T2C_LanguageEnum.english, List.of("[prefix] <dark_red>Vault / Economy not set up!"));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),
        SoundNotFound("Plugin.SoundNotFound", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("[prefix] <dark_red>Der Sound <gold>[sound] <dark_red>wurde nicht gefunden! Bitte überprüfe die Einstellungen."));
                    put(T2C_LanguageEnum.english, List.of("[prefix] <dark_red>The sound <gold>[sound] <dark_red>was not found! Please check the settings."));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        OnlyForPlayer("Plugin.OnlyForPlayer", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("[prefix] <red>Dieser Command ist nur für Spieler!"));
                    put(T2C_LanguageEnum.english, List.of("[prefix] <red>This command is for players only!"));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        DefaultGUIcreate("Plugin.DefaultGUI.create", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("[prefix] <dark_green>DefaultGUI wurde erstellt. Du findest sie im Verzeichnis: <yellow>[directory]<dark_green>!"));
                    put(T2C_LanguageEnum.english, List.of("[prefix] <dark_green>DefaultGUI was created. You can find it in the directory: <yellow>[directory]<dark_green>!"));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        ReloadStart("Plugin.Reload.Start", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("[prefix] <gold>Plugin wird neu geladen..."));
                    put(T2C_LanguageEnum.english, List.of("[prefix] <gold>Plugin is reloaded..."));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        ReloadEnd("Plugin.Reload.End", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("[prefix] <red>Du hast keine Permission für <dark_red>Command<blue>GUI<red>!"));
                    put(T2C_LanguageEnum.english, List.of("[prefix] <dark_green>Plugin was successfully reloaded."));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        NoPermission("NoPermission.ForCommandGUI", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("[prefix] <red>Du hast keine Permission für <dark_red>Command<blue>GUI<red>!"));
                    put(T2C_LanguageEnum.english, List.of("[prefix] <red>You do not have permission for <dark_red>Command<blue>GUI<red>!"));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        NoPermissionForCommand("NoPermission.ForCommand", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("[prefix] <red>Für <aqua>[cmd] <red>fehlt dir die Permission <gold>[perm]<red>!"));
                    put(T2C_LanguageEnum.english, List.of("[prefix] <red>For <aqua>[cmd] <red>you lack the permission <gold>[perm]<red>!"));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        NoPermissionForUseItem("NoPermission.ForUseItem", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("[prefix] <red>Dir fehlt die Permission <gold>[perm] <red>um das Item für die GUI: <gold>[gui] <red>nutzen zu können."));
                    put(T2C_LanguageEnum.english, List.of("[prefix] <red>You lack the permission <gold>[perm] <red>to use the item for the GUI: <gold>[gui]."));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        NoPermissionForItem("NoPermission.ForItem", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("[prefix] <red>Für <aqua>[item] <red>fehlt dir die Permission <gold>[perm]<red>!"));
                    put(T2C_LanguageEnum.english, List.of("[prefix] <red>For <aqua>[item] <red>you lack the permission <gold>[perm]<red>!"));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        ItemON("UseItem.UseItem_ON", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("[prefix] <dark_green>Du hast das GUI-Item aktiviert."));
                    put(T2C_LanguageEnum.english, List.of("[prefix] <dark_green>You have activated the GUI item."));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        ItemOFF("UseItem.UseItem_OFF", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("[prefix] <dark_green>Du hast das GUI-Item deaktiviert."));
                    put(T2C_LanguageEnum.english, List.of("[prefix] <dark_green>You have disabled the GUI item."));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        ItemSlot("UseItem.Change_Slot", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("[prefix] <dark_green>Du hast das GUI-Item auf Slot <gold>[slot] <dark_green>umgestellt."));
                    put(T2C_LanguageEnum.english, List.of("[prefix] <dark_green>You have changed the GUI item to slot: <gold>[slot]<dark_green>."));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        ItemSlotNotEmpty("UseItem.SlotNotEmpty", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("[prefix] <gold>Der Slot §e[slot] §6ist derzeit belegt!."));
                    put(T2C_LanguageEnum.english, List.of("[prefix] <gold>The slot <yellow>[slot] <gold>is currently occupied!"));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        ItemSlotAlreadySet("UseItem.SlotAlreadySet", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("[prefix] <gold>Der Slot §e[slot] §6ist bereits eingestellt!"));
                    put(T2C_LanguageEnum.english, List.of("[prefix] <gold>The slot §e[slot] §6is already set!"));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        ItemSlot_wrongValue("UseItem.ItemSlot_wrongValue", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("[prefix] <red>Der angegebene Slot muss sich zwischen 1 und 9 befinden!"));
                    put(T2C_LanguageEnum.english, List.of("[prefix] <red>The specified slot must be between 1 and 9!"));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        UseItemDisabledInGameMode("UseItem.DisabledInGameMode", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("[prefix] <red>Das UseItem ist in diesem GameMode deaktiviert!"));
                    put(T2C_LanguageEnum.english, List.of("[prefix] <red>The UseItem is disabled in this GameMode!"));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        UseItemDisabledInWorld("UseItem.DisabledInWorld", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("[prefix] <red>Das UseItem ist in dieser Welt deaktiviert!"));
                    put(T2C_LanguageEnum.english, List.of("[prefix] <red>The UseItem is disabled in this World!"));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        Buy_msg("Cost.Buy_msg", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("[prefix] <dark_green>Du hast dir [itemname] <dark_green>für <gold>[price] <dark_green>gekauft."));
                    put(T2C_LanguageEnum.english, List.of("[prefix] <dark_green>You bought [itemname] <dark_green>for <gold>[price]<dark_green>."));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        noMoney("Cost.noMoney", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("<hover:show_text:'<red>Du benötigst [price].'>[prefix] <red>Du hast nicht genügend Geld!</hover>"));
                    put(T2C_LanguageEnum.english, List.of("<hover:show_text:'<red>You need: <gold>[price]<red>.'>[prefix] <red>You don't have enough money!</hover>"));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        noMoneyItem("Cost.noItem", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("<hover:show_text:'<red>Du benötigst: <gold>[amount]<red>.'>[prefix] <red>Du hast nicht genügend Items von <gold>[item] <red>im Inventar!</hover>"));
                    put(T2C_LanguageEnum.english, List.of("<hover:show_text:'<red>You need: <gold>[amount]<red>.'>[prefix] <red>You don't have enough items of <gold>[item] <red>in your inventory!</hover>"));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        noMoneyVote("Cost.noVote", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("<hover:show_text:'<red>Du benötigst: <gold>[amount]<red>.'>[prefix] <red>Du hast nicht genügend Vote Punkte!</hover>"));
                    put(T2C_LanguageEnum.english, List.of("<hover:show_text:'<red>You need: <gold>[amount]<red>.'>[prefix] <red>You do not have enough vote points!</hover>"));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        NoInventorySpace("Cost.NoInventorySpace", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("[prefix] <red>Du hast keinen Platz in deinem Inventar!"));
                    put(T2C_LanguageEnum.english, List.of("[prefix] <red>You have no room in your inventory!"));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        onServerChange("ServerChange.onServerChange", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("[prefix] <dark_green>Du wirst auf den Server §e[server] §2verbunden."));
                    put(T2C_LanguageEnum.english, List.of("[prefix] <dark_green>You will be connected to the server <yellow>[server]§2."));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        guiNotFound("GUI.GUInotFound", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("[prefix] <red>Die von die gew[ae]hlte GUI gibt es nicht."));
                    put(T2C_LanguageEnum.english, List.of("[prefix] <red>The GUI chosen by the does not exist."));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        GUIIsDisabled("GUI.GUIisDisabled", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("[prefix] <red>Die GUI [gui] <red>ist derzeit Deaktiviert!"));
                    put(T2C_LanguageEnum.english, List.of("[prefix] <red>The GUI [gui] <red>is currently Disabled!"));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        Give_Sender("Give.Sender", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("[prefix] <dark_green>Du hast <gold>[player] <dark_green>ein [item] <dark_green>gegeben!"));
                    put(T2C_LanguageEnum.english, List.of("[prefix] <dark_green>You have given <gold>[player] <dark_green>an [item] <dark_green>!"));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        Give_Receiver("Give.Receiver", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("[prefix] <dark_green>Du hast von <gold>[sender] <dark_green>, [item] <dark_green>bekommen!"));
                    put(T2C_LanguageEnum.english, List.of("[prefix] <dark_green>You got <dark_green>, [item] <dark_green>from <gold>[sender]!"));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        PlayerNotFond("Player.PlayerNotFond", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("[prefix] <red>Der Spieler <gold>[player] <red>wurde nicht gefunden oder ist nicht Online!"));
                    put(T2C_LanguageEnum.english, List.of("[prefix] <red>The player <gold>[player] <red>was not found or is not online!"));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        PlayerNoInventorySpace("Player.PlayerNoInventorySpace", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("[prefix] <gold>[player] <red>hat keinen freien Platz in seinem Inventar!"));
                    put(T2C_LanguageEnum.english, List.of("[prefix] <gold>[player] <red>has no free space in his inventory!"));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        functionItemAdd("FunctionItem.Add", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("[prefix] <dark_green>Dir wurden <gold>[amount] [item] <dark_green>in dein Inventar gelegt."));
                    put(T2C_LanguageEnum.english, List.of("[prefix] <dark_green>You have <gold>[amount] [item] <dark_green>placed in your inventory."));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        functionItemRemove("FunctionItem.Remove", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("[prefix] <dark_green>Dir wurden <gold>[amount] [item] <dark_green>entfernt."));
                    put(T2C_LanguageEnum.english, List.of("[prefix] <dark_green>You have been <gold>[amount] [item] <dark_green>removed."));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        functionItemRemoveError("FunctionItem.RemoveError", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("<hover:show_text:'<red>Du benötigst <gold>[amount] [item]<red>!'>[prefix] <red>Du hast nicht so viele Items!</hover>"));
                    put(T2C_LanguageEnum.english, List.of("<hover:show_text:'<red>You need <gold>[amount] [item]<red>!'>[prefix] <red>You don't have so many items!</hover>"));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        functionVoteAdd("FunctionVote.Add", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("[prefix] <dark_green>Dir wurden <gold>[amount] <dark_green>Vote Punkte gegeben."));
                    put(T2C_LanguageEnum.english, List.of("[prefix] <dark_green>You were given <gold>[amount] <dark_green>Vote points."));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        functionVoteRemove("FunctionVote.Remove", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("[prefix] <dark_green>Dir wurden <gold>[amount] <dark_green>Vote Punkte entfernt."));
                    put(T2C_LanguageEnum.english, List.of("[prefix] <dark_green>You have been removed <gold>[amount] <dark_green>Vote points."));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        functionVoteRemoveError("FunctionVote.RemoveError", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("<hover:show_text:'<red>Du benötigst <gold>[amount]<red>!'>[prefix] <red>Du hast nicht so viele VotePunkte!</hover>"));
                    put(T2C_LanguageEnum.english, List.of("<hover:show_text:'<red>You need <gold>[amount]<red>!'>[prefix] <red>You don't have so many VotePoints!</hover>"));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        HelpCgui("Help.CGUI", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("<dark_gray>''<aqua>/commandgui <dark_gray>| <aqua>/cgui<dark_gray>'' <yellow>Öffne die default GUI <gray>(<yellow>[gui]<gray>)<yellow>."));
                    put(T2C_LanguageEnum.english, List.of("<dark_gray>''<aqua>/commandgui <dark_gray>| <aqua>/cgui<dark_gray>'' <yellow>Open the default GUI <gray>(<yellow>[gui]<gray>)<yellow>."));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        HelpHelp("Help.Help", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("<dark_gray>''<aqua>/commandguihelp<dark_gray>'' <yellow>Öffne diese help."));
                    put(T2C_LanguageEnum.english, List.of("<dark_gray>''<aqua>/commandguihelp<dark_gray>'' <yellow>Open this help."));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        HelpInfo("Help.Info", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("<dark_gray>''<aqua>/commandgui admin info<dark_gray>'' <yellow>Rufe die Infos von <dark_red>Command<blue>GUI <yellow>auf."));
                    put(T2C_LanguageEnum.english, List.of("<dark_gray>''<aqua>/commandgui admin info<dark_gray>'' <yellow>Call the info from <dark_red>Command<blue>GUI <yellow>."));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        HelpOpen("Help.Open", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("<dark_gray>''<aqua>/commandgui [gui]<dark_gray>'' <yellow>Öffne die GUI: <gold>[guiname]<yellow>."));
                    put(T2C_LanguageEnum.english, List.of("<dark_gray>''<aqua>/commandgui [gui]<dark_gray>'' <yellow>Open the GUI: <gold>[guiname]<yellow>."));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        HelpGive("Help.Give", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("<dark_gray>''<aqua>/commandgui admin give <gray><player><dark_gray>'' <yellow>Gebe einem Spieler das GUI-Item."));
                    put(T2C_LanguageEnum.english, List.of("<dark_gray>''<aqua>/commandgui admin give <gray><player><dark_gray>'' <yellow>Give a player the GUI item."));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        HelpCreateDefaultGUI("Help.CreateDefaultGUI", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("<dark_gray>''<aqua>/commandgui admin createdefaultgui<dark_gray>'' <yellow>Lasse eine default GUI erstellen <gray>([directory])<yellow>."));
                    put(T2C_LanguageEnum.english, List.of("<dark_gray>''<aqua>/commandgui admin createdefaultgui<dark_gray>'' <yellow>Create a default GUI <gray>([directory])<yellow>."));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        HelpReload("Help.Reload", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("<dark_gray>''<aqua>/commandgui admin reload<dark_gray>'' <yellow>Lade das Plugin neu."));
                    put(T2C_LanguageEnum.english, List.of("<dark_gray>''<aqua>/commandgui admin reload<dark_gray>'' <yellow>Reload the plugin."));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        GUIItemHelp_on("Help.UseItem_On", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("<dark_gray>''<aqua>/gui-item on<dark_gray>'' <yellow>Aktiviere für dich das GUIItem."));
                    put(T2C_LanguageEnum.english, List.of("<dark_gray>''<aqua>/gui-item on<dark_gray>'' <yellow>Activate the GUIItem for you."));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        GUIItemHelp_off("Help.UseItem_Off", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("<dark_gray>''<aqua>/gui-item off<dark_gray>'' <yellow>Deaktiviere für dich das GUIItem."));
                    put(T2C_LanguageEnum.english, List.of("<dark_gray>''<aqua>/gui-item off<dark_gray>'' <yellow>Disable the GUIItem for yourself."));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        GUIItemHelp_Slot("Help.UseItem_Slot", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("<dark_gray>''<aqua>/gui-item slot <gray><slot><dark_gray>'' <yellow>Stelle den Slot ein, auf den du das GUIItem haben möchtest."));
                    put(T2C_LanguageEnum.english, List.of("<dark_gray>''<aqua>/gui-item slot <gray><slot><dark_gray>'' <yellow>Set the slot where you want to have the GUIItem."));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        PlayerHelpCgui("Help.Player.CGUI", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("<hover:show_text:'<yellow>Öffne die default GUI <gray>(<yellow>[gui]<gray>)<yellow>.'><click:suggest_command:'/commandgui'><aqua>/commandgui <dark_gray>| <aqua>/cgui</click></hover>"));
                    put(T2C_LanguageEnum.english, List.of("<hover:show_text:'<yellow>Open the default GUI <gray>(<yellow>[gui]<gray>)<yellow>.'><click:suggest_command:'/commandgui'><aqua>/commandgui <dark_gray>| <aqua>/cgui</click></hover>"));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        PlayerHelpHelp("Help.Player.Help", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("<hover:show_text:'<yellow>Öffne die GUI: <gold>[guiname]<yellow>.'><click:suggest_command:'/commandgui'><aqua>/commandgui [gui]</click></hover>"));
                    put(T2C_LanguageEnum.english, List.of("<hover:show_text:'<yellow>Open the GUI: <gold>[guiname]<yellow>.'><click:suggest_command:'/commandgui'><aqua>/commandgui [gui]</click></hover>"));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        PlayerHelpInfo("Help.Player.Info", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("<hover:show_text:'<yellow>Öffne diese help.'><click:suggest_command:'/commandguihelp'><aqua>/commandguihelp</click></hover>"));
                    put(T2C_LanguageEnum.english, List.of("<hover:show_text:'<yellow>Open this help.'><click:suggest_command:'/commandguihelp'><aqua>/commandguihelp</click></hover>"));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        PlayerHelpOpen("Help.Player.Open", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("<hover:show_text:'<yellow>Rufe die Infos von <dark_red>Command<blue>GUI <yellow>auf.'><click:suggest_command:'/commandgui admin info'><aqua>/commandgui admin info</click></hover>"));
                    put(T2C_LanguageEnum.english, List.of("<hover:show_text:'<yellow>Call the info from <dark_red>Command<blue>GUI <yellow>'><click:suggest_command:'/commandgui admin info'><aqua>/commandgui admin info</click></hover>"));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        PlayerHelpGive("Help.Player.Give", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("<hover:show_text:'<yellow>Gebe einem Spieler das GUI-Item.'><click:suggest_command:'/commandgui admin give'><aqua>/commandgui admin give <gray><player></click></hover>"));
                    put(T2C_LanguageEnum.english, List.of("<hover:show_text:'<yellow>Give a player the GUI item.'><click:suggest_command:'/commandgui admin give'><aqua>/commandgui admin give <gray><player></click></hover>"));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        PlayerHelpCreateDefaultGUI("Help.Player.CreateDefaultGUI", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("<hover:show_text:'<yellow>Lasse eine default GUI erstellen <gray>([directory])<yellow>.'><click:suggest_command:'/commandgui admin createdefaultgui'><aqua>/commandgui admin createdefaultgui</click></hover>"));
                    put(T2C_LanguageEnum.english, List.of("<hover:show_text:'<yellow>Create a default GUI <gray>([directory])<yellow>.'><click:suggest_command:'/commandgui admin createdefaultgui'><aqua>/commandgui admin createdefaultgui</click></hover>"));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        PlayerHelpReload("Help.Player.Reload", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("<hover:show_text:'<yellow>Lade das Plugin neu.'><click:suggest_command:'/commandgui admin reload'><aqua>/commandgui admin reload</click></hover>"));
                    put(T2C_LanguageEnum.english, List.of("<hover:show_text:'<yellow>Reload the plugin.'><click:suggest_command:'/commandgui admin reload'><aqua>/commandgui admin reload</click></hover>"));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        PlayerGUIItemHelp_on("Help.Player.UseItem_On", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("<hover:show_text:'<yellow>Aktiviere für dich das GUIItem.'><click:suggest_command:'/gui-item on'><aqua>/gui-item on</click></hover>"));
                    put(T2C_LanguageEnum.english, List.of("<hover:show_text:'<yellow>Activate the GUIItem for you.'><click:suggest_command:'/gui-item on'><aqua>/gui-item on</click></hover>"));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        PlayerGUIItemHelp_off("Help.Player.UseItem_Off", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("<hover:show_text:'<yellow>Deaktiviere für dich das GUIItem.'><click:suggest_command:'/gui-item off'><aqua>/gui-item off</click></hover>"));
                    put(T2C_LanguageEnum.english, List.of("<hover:show_text:'<yellow>Disable the GUIItem for yourself.'><click:suggest_command:'/gui-item off'><aqua>/gui-item off</click></hover>"));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        PlayerGUIItemHelp_Slot("Help.Player.UseItem_Slot", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("<hover:show_text:'<yellow>Stelle den Slot ein, auf den du das GUIItem haben möchtest.'><click:suggest_command:'/gui-item slot'><aqua>/gui-item slot <gray><slot></click></hover>"));
                    put(T2C_LanguageEnum.english, List.of("<hover:show_text:'<yellow>Set the slot where you want to have the GUIItem.'><click:suggest_command:'/gui-item slot'><aqua>/gui-item slot <gray><slot></click></hover>"));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),
        ;

        private final String path;
        private Object value;
        private final HashMap<T2C_LanguageEnum, List<String>> lang;
        private final HashMap<T2C_LanguageEnum, List<String>> comments;

        VALUES(String path, Object value, HashMap<T2C_LanguageEnum, List<String>> lang, HashMap<T2C_LanguageEnum, List<String>> comments) {
            this.path = path;
            this.value = value;
            this.lang = lang;
            this.comments = comments;
        }

        @Override
        public String getPath() {
            return path;
        }

        @Override
        public Object getValue() {
            if (value == null) {
                return lang.get(T2C_LanguageEnum.english);
            }
            return value;
        }

        @Override
        public HashMap<T2C_LanguageEnum, List<String>> getLanguage() {
            return lang;
        }

        @Override
        public HashMap<T2C_LanguageEnum, List<String>> getComments() {
            return comments;
        }

        @Override
        public void setValue(Object newValue) {
            value = T2C_Replace.replace(Config.VALUES.prefix.getValue().toString(), newValue.toString());
        }
    }

    public static void set(boolean isReload) {
        T2C_LanguageWriter.createConfig(Util.getPrefix(), Main.getPath(), VALUES.values(), Config.VALUES.language.getValue().toString(), isReload, Util.getConfigLogo());
    }
}
