package net.t2code.commandguiv2.Spigot.system;

import net.t2code.commandguiv2.Spigot.config.config.Config;
import net.t2code.commandguiv2.Spigot.config.functions.FunctionsFile;
import net.t2code.commandguiv2.Spigot.config.gui.GuiFile;
import net.t2code.commandguiv2.Spigot.config.languages.Languages;
import net.t2code.commandguiv2.Spigot.gui.GUIListener;
import net.t2code.commandguiv2.Spigot.listener.Bungee_Sender_Reciver;
import net.t2code.commandguiv2.Spigot.useItem.EventsFrom110;
import net.t2code.commandguiv2.Spigot.cmdManagement.CmdExecuter_GUI;
import net.t2code.commandguiv2.Spigot.cmdManagement.CmdExecuter_GUIItem;
import net.t2code.commandguiv2.Spigot.cmdManagement.CmdExecuter_Help;
import net.t2code.commandguiv2.Spigot.cmdManagement.register.AliasRegister;
import net.t2code.commandguiv2.Spigot.database.MySQL;
import net.t2code.commandguiv2.Spigot.listener.PluginEvent;
import net.t2code.commandguiv2.Spigot.useItem.Events;
import net.t2code.commandguiv2.Spigot.Main;
import net.t2code.commandguiv2.Spigot.database.SQLITE;
import net.t2code.commandguiv2.Spigot.database.SelectDatabase;
import net.t2code.commandguiv2.Spigot.enums.StorageEnum;
import net.t2code.commandguiv2.Util;
import net.t2code.t2codelib.SPIGOT.api.debug.T2C_Debug;
import net.t2code.t2codelib.SPIGOT.api.messages.T2C_Send;
import net.t2code.t2codelib.SPIGOT.api.messages.T2C_Template;
import net.t2code.t2codelib.SPIGOT.api.minecraftVersion.T2C_McVersion;
import net.t2code.t2codelib.SPIGOT.api.plugins.T2C_PluginCheck;
import net.t2code.t2codelib.SPIGOT.api.update.T2C_UpdateAPI;
import net.t2code.t2codelib.SPIGOT.system.config.config.T2C_LibConfig;
import net.t2code.t2codelib.util.T2C_Util;
import org.bukkit.Bukkit;
import org.bukkit.plugin.Plugin;

import java.io.*;
import java.sql.SQLException;
import java.util.List;

public class Load {
    static Plugin plugin = Main.getPlugin();

    public static void onLoad(String prefix, List<String> autor, String version, String spigot, int spigotID, String discord, int bstatsID) {

        long long_ = T2C_Template.onLoadHeader(prefix, autor, version, spigot, discord);

        Debug.debugmsg();

        if (!new File(Main.getPath(), "config.yml").exists()) {
            GuiFile.createDefault(false);
            FunctionsFile.createDefault(false);
        }
        Config.set(false);

        if ((boolean) T2C_LibConfig.VALUES.proxy.getValue()) {
            if (!Bukkit.getMessenger().isOutgoingChannelRegistered(plugin, T2C_Util.getPluginChannel_ProxyCommand())) {
                T2C_Debug.debug(plugin, "registerOutgoingPluginChannel §e" + T2C_Util.getPluginChannel_ProxyCommand());
                Bukkit.getMessenger().registerOutgoingPluginChannel(plugin, T2C_Util.getPluginChannel_ProxyCommand());
            }
            if (!Bukkit.getMessenger().isIncomingChannelRegistered(plugin, T2C_Util.getPluginChannel_CGUIOnlinePlayers())) {
                T2C_Debug.debug(plugin, "registerIncomingPluginChannel §e" + T2C_Util.getPluginChannel_CGUIOnlinePlayers());
                Bukkit.getMessenger().registerIncomingPluginChannel(plugin, T2C_Util.getPluginChannel_CGUIOnlinePlayers(), new Bungee_Sender_Reciver());
            }
        }

        if (T2C_PluginCheck.papi()) {
            new Papi().register();
        }

        FunctionsFile.select(false);
        GuiFile.set(false);

        Languages.set(false);
        Config.checkSounds();

        CmdExecuter_GUI.arg1.put(Config.VALUES.adminSubCommand.getValue().toString(), Permissions.admin + ";" + Permissions.giveItemOther + ";" + Permissions.info);

        T2C_Template.onLoadSeparateStroke(Util.getPrefix());
        loadStorage(prefix);
        T2C_Template.onLoadSeparateStroke(Util.getPrefix());

        if (Main.PaPi) {
            T2C_Send.sendStartTextCenter(Util.getPrefix(),"§2PlaceholderAPI successfully connected!",false);
        } else {
            T2C_Send.sendStartTextCenter(Util.getPrefix(),"§4PlaceholderAPI could not be connected / found!",false);
        }

        Permissions.onPermRegister();

        if ((boolean) Config.VALUES.helpAlias.getValue()) {
            Main.getPlugin().getCommand("commandguihelp").setExecutor(new CmdExecuter_Help());
            T2C_Debug.debug(plugin, "CommandRegister: commandguihelp");
        }
        Main.getPlugin().getCommand("commandgui").setExecutor(new CmdExecuter_GUI());
        T2C_Debug.debug(plugin, "CommandRegister: commandgui");
        Main.getPlugin().getCommand("commandgui-item").setExecutor(new CmdExecuter_GUIItem());
        T2C_Debug.debug(plugin, "CommandRegister: commandgui-item");

        AliasRegister.onRegister(false);

        Bukkit.getServer().getPluginManager().registerEvents(new GUIListener(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new PluginEvent(), plugin);

        Bukkit.getServer().getPluginManager().registerEvents(new Events(), Main.getPlugin());

        if (!T2C_McVersion.isMc1_8() && !T2C_McVersion.isMc1_9()) {
            Bukkit.getServer().getPluginManager().registerEvents(new EventsFrom110(), plugin);
        }

        T2C_UpdateAPI.onUpdateCheck(plugin, prefix, Util.getGit(), spigotID, discord
                , (boolean) Config.VALUES.updateCheckOnJoin.getValue(), (boolean) Config.VALUES.updateCheckSeePreReleaseUpdates.getValue(), (int) Config.VALUES.updateCheckTimeInterval.getValue());
        Metrics.Bstats();
        Main.addonLoad();
        T2C_Template.onLoadFooter(prefix, long_);
        Plugman.load();
    }

    private static void loadStorage(String prefix) {
        try {
            SelectDatabase.setStorage(StorageEnum.valueOf(Config.VALUES.storage.getValue().toString()));
        } catch (Exception ignored) {
            T2C_Send.error(plugin, "The storage medium " + Config.VALUES.storage.getValue().toString() + " is not supported!");
            T2C_Send.error(plugin, "Storage medium " + StorageEnum.SQLITE + " is used.");
            SelectDatabase.setStorage(StorageEnum.SQLITE);
        }

        switch (SelectDatabase.getStorage()) {
            case MYSQL:
                T2C_Send.sendStartTextCenter(prefix,"§2Storage medium §6" + SelectDatabase.getStorage() + " §2is used.",false);
                MySQL.main();
                try {
                    MySQL.query("CREATE TABLE IF NOT EXISTS `gui-item` (" +
                            "    `UUID` VARCHAR(191) NOT NULL COLLATE 'utf8mb4_general_ci'," +
                            "    `Name` TINYTEXT NOT NULL COLLATE 'utf8mb4_general_ci'," +
                            "    `Status` INT(1) NOT NULL DEFAULT '1'," +
                            "    `Slot` INT(1) NULL DEFAULT NULL," +
                            "     UNIQUE INDEX `UUID` (`UUID`)" +
                            ")" +
                            "COLLATE='utf8mb4_general_ci'" +
                            "ENGINE=InnoDB" +
                            ";");
                } catch (Exception e) {
                    Main.sendTryCatch(Load.class, e.getStackTrace()[0]);
                    e.printStackTrace();
                }
                try {
                    MySQL.query("ALTER TABLE `gui-item` ADD COLUMN `Slot` INT(1) NULL DEFAULT NULL AFTER `Status`;");
                } catch (SQLException e) {
                }
                break;
            case YML:
                T2C_Send.sendStartTextCenter(prefix,"§2Storage medium §6" + SelectDatabase.getStorage() + " §2is used.",false);
                break;
            default:
            case SQLITE:
                T2C_Send.sendStartTextCenter(prefix,"§2Storage medium §6" + SelectDatabase.getStorage() + " §2is used.",false);
                try {
                    SQLITE.main();
                    SQLITE.query("CREATE TABLE IF NOT EXISTS `gui-item` (" +
                            "UUID TEXT NOT NULL," +
                            "Name TEXT NOT NULL," +
                            "Status INTEGER NOT NULL DEFAULT 1," +
                            "Slot INTEGER," +
                            "PRIMARY KEY(UUID)" +
                            ");");
                } catch (SQLException e) {
                    e.printStackTrace();
                }
                break;
        }
    }
}
