package net.t2code.commandguiv2.Spigot.system;

import net.t2code.commandguiv2.Spigot.Main;
import net.t2code.commandguiv2.Spigot.objects.Gui;
import net.t2code.commandguiv2.Spigot.objects.Slot;
import net.t2code.t2codelib.SPIGOT.api.register.T2C_Register;
import org.bukkit.permissions.PermissionDefault;
import org.bukkit.plugin.Plugin;

public class Permissions {
    private static final Plugin plugin = Main.getPlugin();

    public static final String key = "commandgui.";
    public static final String command = key + "command";
    public static final String info = key + "command.info";
    public static final String bypass = key + "bypass";
    public static final String useitemToggle = key + "useitem.toggle";
    public static final String useitem = key + "useitem";
    public static final String getGuiItemAtLogin = key + "get.guiitem.at.login";
    public static final String giveItemOther = key + "giveitem.other";
    public static final String updatemsg = key + "updatemsg";

    public static final String player = key + "player";
    public static final String admin = key + "admin";

    public static final PermissionDefault op = PermissionDefault.OP;
    public static final PermissionDefault notOp = PermissionDefault.NOT_OP;

    public static void onPermRegister() {
        T2C_Register.permission(command, op, plugin);
        T2C_Register.permissionDescription(command, "Required permission to open GUIs via command", plugin);

        T2C_Register.permission(getGuiItemAtLogin, op, plugin);
        T2C_Register.permission(giveItemOther, op, plugin);
        T2C_Register.permissionDescription(getGuiItemAtLogin, "Only players with this permission will receive the GUI item", plugin);

        T2C_Register.permission(useitem, op, plugin);
        T2C_Register.permissionDescription(useitem, "Required permission to use the GUI Item", plugin);

        T2C_Register.permission(useitemToggle, op, plugin);
        T2C_Register.permissionDescription(useitemToggle, "Required permission to enable/disable the GUI Item for itself (if the function UseItem/AllowToggle is set to true)", plugin);

        T2C_Register.permission(updatemsg, op, plugin);
        T2C_Register.permissionDescription(updatemsg, "Players with this permission get the update message when joining if an update is available", plugin);

        T2C_Register.permission(bypass, op, plugin);
        T2C_Register.permissionDescription(bypass, "Bypass to open disabled GUIs", plugin);

        T2C_Register.permission(info, notOp, plugin);
        T2C_Register.permissionDescription(info, "Permission to view T2C-CommandGUI info", plugin);

        T2C_Register.permission(player, op, command, true, plugin);
        T2C_Register.permission(player, op, getGuiItemAtLogin, true, plugin);
        T2C_Register.permission(player, op, useitem, true, plugin);
        T2C_Register.permission(player, op, useitemToggle, true, plugin);
        T2C_Register.permissionDescription(player, "All permissions from T2C-CommandGUI for Player", plugin);

        T2C_Register.permission(admin, op, command, true, plugin);
        T2C_Register.permission(admin, op, getGuiItemAtLogin, true, plugin);
        T2C_Register.permission(admin, op, giveItemOther, true, plugin);
        T2C_Register.permission(admin, op, useitem, true, plugin);
        T2C_Register.permission(admin, op, useitemToggle, true, plugin);
        T2C_Register.permission(admin, op, updatemsg, true, plugin);
        T2C_Register.permission(admin, op, bypass, true, plugin);
        T2C_Register.permission(admin, op, info, true, plugin);
        T2C_Register.permissionDescription(admin, "All permissions from T2C-CommandGUI", plugin);


        for (Gui gui : Main.guiHashMap.values()) {
            T2C_Register.permission(command + "." + gui.key, op, plugin);
            T2C_Register.permission(admin, op, command + "." + gui.key, true, plugin);
            for (Slot slot : gui.slots) {
                T2C_Register.permission(slot.permissionToUse, op, plugin);
                T2C_Register.permission(admin, op, slot.permissionToUse, true, plugin);
                T2C_Register.permission(slot.permissionToSee, op, plugin);
                T2C_Register.permission(admin, op, slot.permissionToSee, true, plugin);
            }
        }
    }
}
